--  2005-07-19AI
require "./AI/Const.lua"
require "./AI/Util.lua"

-----------------------------
-- ۥ󥯥륹
-----------------------------
IDLE_ST					= 0  -- Ե
FOLLOW_ST				= 1  -- 륱ߥɽ
CHASE_ST				= 2  -- å׾
ATTACK_ST				= 3  -- 
MOVE_CMD_ST				= 4  -- ưޥɼվ
STOP_CMD_ST				= 5  -- ߥޥɼվ
ATTACK_OBJECT_CMD_ST			= 6  -- оݻ깶⥳ޥɼվ
ATTACK_AREA_CMD_ST			= 7  -- ϰϹ⥳ޥɼվ
PATROL_CMD_ST				= 8  -- ѥȥʱư˥ޥɼվ
HOLD_CMD_ST				= 9  -- ۡɥޥɼվ
SKILL_OBJECT_CMD_ST			= 10 -- оݻꥹ륳ޥɼվ
SKILL_AREA_CMD_ST			= 11 -- ϰϥ륳ޥɼվ
FOLLOW_CMD_ST				= 12 -- ɽޥɼվ
----------------------------



------------------------------------------
-- ХѿʥץΤǶ̤ǻȤե饰ߤʤΡ
------------------------------------------
MyState				= IDLE_ST	-- ۥθ߾֡ʽͤԵ֡
MyEnemy				= 0		-- ۥबåȤƤŨΥ饯ID
MyDestX				= 0		-- ۥɸɸXʰư / Ѻɸ
MyDestY				= 0		-- ۥɸɸYʰư / Ѻɸ
MyPatrolX			= 0		-- ۥबѥȥʱưˤɸX
MyPatrolY			= 0		-- ۥबѥȥʱưˤɸY
-- ʥߤԤʣޥϤ硢˽֤˵ޤ
ResCmdList			= List.new()	-- ϥޥɥꥹ
MyID				= 0		-- ۥ༫ȤΥ饯ID
MySkill				= 0		-- ۥबȤȤƤ륹
MySkillLevel			= 0		-- ۥबȤȤƤ륹٥
------------------------------------------









------------- ޥɤȤν  ---------------------

-------------------------------------------
-- ưޥɤդν
--   <> X : ưXɸ
--          Y : ưYɸ
-------------------------------------------
function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")		-- ǥХåʸ

	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		return	-- ۥκɸưɸɸƱǡĥۥबư⡼ʤв⤷ʤ

	end

	-- ߤȥۥδ֤εΥ (x,y)
	local curX, curY = GetV (V_POSITION,MyID)
	-- ߤȥۥεΥ15ޥʾΤȤ
	if (math.abs(x-curX)+math.abs(y-curY) > 15) then	-- ŪϤΥʾʤ (СǱΥϽʤ)
		List.pushleft (ResCmdList,{MOVE_CMD,x,y})	-- ŪϤؤΰưͽ󤹤롣
		x = math.floor((x+curX)/2)	-- ˰ư롣
		y = math.floor((y+curY)/2)	-- 
	end

	Move (MyID,x,y)			-- (x,y)ɸ˥ۥư
	
	MyState = MOVE_CMD_ST		-- ۥ֤ưޥɼվ֤ˤ
	MyDestX = x					-- ưxɸxˤ
	MyDestY = y					-- ưyɸyˤ
	MyEnemy = 0					-- ˤƤŨ饿
	MySkill = 0					-- ˤƤŨ饿

end


-------------------------------------------
-- ߥޥɤդν
-------------------------------------------
function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")		-- ǥХåʸ

	-- ۥबΩ⡼Ǥʤ
	if (GetV(V_MOTION,MyID) ~= MOTION_STAND) then
		Move (MyID,GetV(V_POSITION,MyID))		-- ۥθ֤߰
	end
	MyState = IDLE_ST			-- ۥ֤Ե֤ˤ
	MyDestX = 0					-- ɸxɸ򥯥ꥢ
	MyDestY = 0					-- ɸyɸ򥯥ꥢ
	MyEnemy = 0					-- ˤƤŨ饿
	MySkill = 0					-- Ѥ褦ȤƤ륹뤬ä饭󥻥

end


-------------------------------------------
-- оݻ깶⥳ޥɤդν
--   <> id : оݤΥ饯id
-------------------------------------------
function	OnATTACK_OBJECT_CMD (id)

	TraceAI ("OnATTACK_OBJECT_CMD")		-- ǥХåʸ

	MySkill = 0		-- Ѥ褦ȤƤ륹뤬ä饭󥻥
	MyEnemy = id		-- idŨ򥿡åȤˤ
	MyState = CHASE_ST	-- ۥ֤򥿡å׾֤ˤ

end


-------------------------------------------
-- оݻ깶⥳ޥɤդν
--   <> x : ϰϤ濴xɸ
--          y : ϰϤ濴yɸ
-------------------------------------------
function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")	-- ǥХåʸ

	-- ۥκɸɸɸȰ㤦ۥबư⡼Ǥʤ
	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION,MyID)) then
		Move (MyID,x,y)				-- (x,y)ɸ˥ۥư
	end
	MyDestX = x						-- ɸxɸxˤ
	MyDestY = y						-- ɸyɸyˤ
	MyEnemy = 0						-- ˤƤŨ饿
	MyState = ATTACK_AREA_CMD_ST	-- ۥ֤ϰϹ⥳ޥɼվ֤ˤ
	
end


-------------------------------------------
-- ѥȥ륳ޥɤդν
-- ѥȥǤϡۥϸ֤߰Ȼ֤
--   <> x : ѥȥxɸ
--          y : ѥȥyɸ
-------------------------------------------
function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")	-- ǥХåʸ

	-- ۥθߺɸѥȥ볫Ϻɸˤ
	MyPatrolX , MyPatrolY = GetV (V_POSITION,MyID)
	MyDestX = x					-- ɸxɸxˤ
	MyDestY = y					-- ɸyɸyˤ
	Move (MyID,x,y)				-- (x,y)ɸ˥ۥư
	MyState = PATROL_CMD_ST		-- ۥ֤ѥȥ륳ޥɼվ֤ˤ

end


-------------------------------------------
-- ۡɥޥɤդν
-------------------------------------------
function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")		-- ǥХåʸ

	MyDestX = 0					-- ɸxɸ򥯥ꥢ
	MyDestY = 0					-- ɸyɸ򥯥ꥢ
	MyEnemy = 0					-- ˤƤŨ饿
	MyState = HOLD_CMD_ST		-- ۥ֤ۡɥޥɼվ֤ˤ

end


-------------------------------------------
-- оݻꥹ륳ޥɤդν
--   <> level : ѥ٥
--          skill : ѥ
--          id    : оݤΥ饯id
-------------------------------------------
function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI ("OnSKILL_OBJECT_CMD")		-- ǥХåʸ

	MySkillLevel = level		-- ѥ٥
	MySkill = skill				-- ѥ
	MyEnemy = id				-- idŨ򥿡åȤˤ
	MyState = CHASE_ST			-- ۥ֤򥿡å׾֤ˤ

end


-------------------------------------------
-- ϰϥ륳ޥɤդν
--   <> level : ѥ٥
--          skill : ѥ
--          x     : xɸ
--          y     : yɸ
-------------------------------------------
function	OnSKILL_AREA_CMD (level,skill,x,y)

	TraceAI ("OnSKILL_AREA_CMD")	-- ǥХåʸ

	Move (MyID,x,y)					-- (x,y)ɸ˥ۥư
	MyDestX = x					-- ɸxɸxˤ
	MyDestY = y					-- ɸyɸyˤ
	MySkillLevel = level		-- ѥ٥
	MySkill = skill				-- ѥ
	MyState = SKILL_AREA_CMD_ST	-- ϰϥ륳ޥɼվ֤ˤ
	
end


-------------------------------------------
-- ɽޥɤդν
-------------------------------------------
function	OnFOLLOW_CMD ()

	-- ԵޥɤϡԵ֤ɽޥɼվ֤ߤ˷֤
	if (MyState ~= FOLLOW_CMD_ST) then	-- ɽޥɼվ֤ǤϤʤʤ
		MoveToOwner (MyID)				-- ߤΤȤޤǰư
		MyState = FOLLOW_CMD_ST			-- ɽޥɼվ
		MyDestX, MyDestY = GetV (V_POSITION,GetV(V_OWNER,MyID))		-- ߤ֤ɸɸˤ
		MyEnemy = 0					-- ˤƤŨ饿
		MySkill = 0					-- Ѥ褦ȤƤ륹뤬ä饭󥻥
		TraceAI ("OnFOLLOW_CMD")	-- ǥХåʸ
	else	-- ɽޥɼվ֤ΤȤ
		MyState = IDLE_ST		-- ۥ֤Ե֤ˤ
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("FOLLOW_CMD_ST --> IDLE_ST")	-- ǥХåʸ
	end

end


-------------------------------------------
-- ޥϤοʬ
-------------------------------------------
function	ProcessCommand (msg)
	-- ߤϤʲΥޥɤλб륳ޥɼսƤӽФ
	if		(msg[1] == MOVE_CMD) then	-- ưޥ
		OnMOVE_CMD (msg[2],msg[3])
		TraceAI ("MOVE_CMD")
	elseif	(msg[1] == STOP_CMD) then	-- ߥޥ
		OnSTOP_CMD ()
		TraceAI ("STOP_CMD")
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then	-- оݻ깶⥳ޥ
		OnATTACK_OBJECT_CMD (msg[2])
		TraceAI ("ATTACK_OBJECT_CMD")
	elseif	(msg[1] == ATTACK_AREA_CMD) then	-- ϰϹ⥳ޥ
		OnATTACK_AREA_CMD (msg[2],msg[3])
		TraceAI ("ATTACK_AREA_CMD")
	elseif	(msg[1] == PATROL_CMD) then	-- ѥȥ륳ޥ
		OnPATROL_CMD (msg[2],msg[3])
		TraceAI ("PATROL_CMD")
	elseif	(msg[1] == HOLD_CMD) then	-- ۡɥޥ
		OnHOLD_CMD ()
		TraceAI ("HOLD_CMD")
	elseif	(msg[1] == SKILL_OBJECT_CMD) then	-- оݻꥹ륳ޥ
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_OBJECT_CMD")
	elseif	(msg[1] == SKILL_AREA_CMD) then	-- ϰϥ륳ޥ
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_AREA_CMD")
	elseif	(msg[1] == FOLLOW_CMD) then	-- ɽޥ
		OnFOLLOW_CMD ()
		TraceAI ("FOLLOW_CMD")
	end
end


-------------- ۥ֤Ȥν  --------------------

-------------------------------------------
-- Ե֤ν
-------------------------------------------
function	OnIDLE_ST ()
	
	TraceAI ("OnIDLE_ST")

	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then	-- ޥϤ
		ProcessCommand (cmd)	-- б륳ޥɤμսԤ
		return 
	end

	local	object = GetOwnerEnemy (MyID)	-- ߤ򹶷⤷ƤŨΥ饯id
	if (object ~= 0) then			-- ߤ򹶷⤷ƤŨʤ
		MyState = CHASE_ST	-- ۥ֤򥿡å׾֤ˤ
		MyEnemy = object	-- objectŨ򥿡åȤˤ
		TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
		return	-- 
	end

	object = GetMyEnemy (MyID)	-- ۥŨΥ饯id
	if (object ~= 0) then		-- ۥŨʤ
		MyState = CHASE_ST	-- ۥ֤򥿡å׾֤ˤ
		MyEnemy = object	-- objectŨ򥿡åȤˤ
		TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
		return	-- 
	end

	local distance = GetDistanceFromOwner(MyID)	-- ߤȤεΥ
	if ( distance > 3 or distance == -1) then	-- ߤޤǤεΥΥ3󤤤볦ʤ
		MyState = FOLLOW_ST	-- ۥ֤ɽ֤ˤ
		TraceAI ("IDLE_ST -> FOLLOW_ST")
		return;	-- 
	end

end


-------------------------------------------
-- ɽ֤ν
-------------------------------------------
function	OnFOLLOW_ST ()

	TraceAI ("OnFOLLOW_ST")

	if (GetDistanceFromOwner(MyID) <= 3) then		-- ߤȤεΥ3ʤ
		MyState = IDLE_ST	-- ۥ֤Ե֤ˤ
		TraceAI ("FOLLOW_ST -> IDLW_ST")
		return;
	-- ߤȤεΥ3⤸ʤơۥΥ⡼Ω⡼ʤ
	elseif (GetV(V_MOTION,MyID) == MOTION_STAND) then
		MoveToOwner (MyID)	-- ߤΤȤޤǰư
		TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		return;
	end

end


-------------------------------------------
-- å׾֤ν
-------------------------------------------
function	OnCHASE_ST ()

	TraceAI ("OnCHASE_ST")

	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- Ũ볦˽Фʤ
		MyState = IDLE_ST	-- ۥ֤Ե֤ˤ
		MyEnemy = 0	-- ˤƤŨ饿
		MyDestX, MyDestY = 0,0	-- ɸɸХꥢ
		TraceAI ("CHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	if (true == IsInAttackSight(MyID,MyEnemy)) then	-- ŨϰϤä
		MyState = ATTACK_ST	-- ۥ֤򹶷֤ˤ
		TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		return
	end

	local x, y = GetV (V_POSITION,MyEnemy)	-- Ũκɸ
	if (MyDestX ~= x or MyDestY ~= y) then			-- ɸɸŨʤ
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);	-- Ũκɸɸɸˤ
		Move (MyID,MyDestX,MyDestY)	-- Ũκɸذư
		TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN")
		return
	end

end


-------------------------------------------
-- ֤ν
-------------------------------------------
function	OnATTACK_ST ()

	TraceAI ("OnATTACK_ST")
	
	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- Ũ볦˽Ф
		MyState = IDLE_ST	-- ۥ֤Ե֤ˤ
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return 
	end

	if (MOTION_DEAD == GetV(V_MOTION,MyEnemy)) then	-- Ũ˥⡼ˤʤä
		MyState = IDLE_ST	-- ۥ֤Ե֤ˤ
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return
	end
		
	if (false == IsInAttackSight(MyID,MyEnemy)) then	-- Ũ볦γ˽Ф
		MyState = CHASE_ST	-- ۥ֤׾֤ˤ
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);	-- Ũκɸɸɸˤ
		Move (MyID,MyDestX,MyDestY)	-- Ũκɸذư
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN")
		return
	end
	
	if (MySkill == 0) then	-- ȤȤƤ륹뤬ʤ
		Attack (MyID,MyEnemy)	-- Ũ򹶷
	else	-- ȤȤƤ륹뤬
		SkillObject (MyID,MySkillLevel,MySkill,MyEnemy)	-- ŨФоݻꥹȯư
		MySkill = 0	-- ʸѤ褦ȤƤ륹뤬Х󥻥
	end
	TraceAI ("ATTACK_ST -> ATTACK_ST  : ENERGY_RECHARGED_IN")
	return


end


-------------------------------------------
-- ưޥɼվ֤ν
-------------------------------------------
function	OnMOVE_CMD_ST ()

	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,MyID)	-- ۥθߺɸ
	if (x == MyDestX and y == MyDestY) then		-- ɸɸˤ
		MyState = IDLE_ST	-- ۥ֤Ե֤ˤ
	end
end



-------------------------------------------
-- ߥޥɼվ֤ν
-------------------------------------------
function OnSTOP_CMD_ST ()


end


-------------------------------------------
-- оݻ깶⥳ޥɼվ֤ν
-------------------------------------------
function OnATTACK_OBJECT_CMD_ST ()


end


-------------------------------------------
-- ϰϹ⥳ޥɼվ֤ν
-------------------------------------------
function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local	object = GetOwnerEnemy (MyID)	-- ߤ򹶷⤷ƤŨΥ饯id
	if (object == 0) then			-- ߤ򹶷⤷ƤŨʤ
		object = GetMyEnemy (MyID) 	-- ۥŨΥ饯id
	end

	if (object ~= 0) then		-- ŨСʥߤ⤹ޤϹ⤵
		MyState = CHASE_ST	-- ۥ֤򥿡å׾֤ˤ
		MyEnemy = object	-- objectŨ򥿡åȤˤ
		return
	end

	local x , y = GetV (V_POSITION,MyID)	-- ۥθߺɸ
	if (x == MyDestX and y == MyDestY) then		-- ɸɸˤ
			MyState = IDLE_ST	-- ۥ֤Ե֤ˤ
	end

end


-------------------------------------------
-- ѥȥ륳ޥɼվ֤ν
-------------------------------------------
function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local	object = GetOwnerEnemy (MyID)	-- ߤ򹶷⤷ƤŨΥ饯id
	if (object == 0) then		-- ߤ򹶷⤷ƤŨʤ
		object = GetMyEnemy (MyID)	-- ۥŨΥ饯id
	end

	if (object ~= 0) then		-- Ũ
		MyState = CHASE_ST	-- ۥ֤򥿡å׾֤ˤ
		MyEnemy = object	-- objectŨ򥿡åȤˤ
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,MyID)	-- ۥθߺɸ
	if (x == MyDestX and y == MyDestY) then		-- ɸɸˤ
		MyDestX = MyPatrolX	-- ѥȥɸ򿷤ɸɸˤ
		MyDestY = MyPatrolY
		MyPatrolX = x	-- ֤߰򿷤ѥȥɸˤ
		MyPatrolY = y
		Move (MyID,MyDestX,MyDestY)	-- ɸɸذư
	end

end


-------------------------------------------
-- ۡɥޥɼվ֤ν
-- Ũ֤˹⤹
-------------------------------------------
function OnHOLD_CMD_ST ()

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then	-- Ũ
		local d = GetDistance(MyEnemy,MyID)	-- ۥŨȤεΥ
		-- Ũ볦ˤƹϰϤäƤ
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,MyID)) then
				Attack (MyID,MyEnemy)	-- Ũ򹶷
		else	-- ʳʤ
			MyEnemy = 0;	-- Ũ򥿥鳰
		end
		return			-- 
	end


	local	object = GetOwnerEnemy (MyID)	-- ߤ򹶷⤷ƤŨΥ饯id
	if (object == 0) then	-- ߤ򹶷⤷ƤŨʤ
		object = GetMyEnemy (MyID)	-- ۥŨΥ饯id
		if (object == 0) then	-- ۥŨʤ

			return		-- 
		end
	end

	MyEnemy = object	-- Ũ򥿥ˤ

end


-------------------------------------------
-- оݻꥹ륳ޥɼվ֤ν
-------------------------------------------
function OnSKILL_OBJECT_CMD_ST ()
	
end


-------------------------------------------
-- ϰϥ륳ޥɼվ֤ν
-------------------------------------------
function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,MyID)	-- ۥθߺɸ
	-- ɸȤȤƤ륹μϰʤ
	if (GetDistance(x,y,MyDestX,MyDestY) <= GetV(V_SKILLATTACKRANGE,MyID,MySkill)) then
		-- ϰϥȯư
		SkillGround (MyID,MySkillLevel,MySkill,MyDestX,MyDestY)
		MyState = IDLE_ST	-- ۥ֤Ե֤ˤ
		MySkill = 0	-- Ѥ褦ȤƤ륹뤬Х󥻥
	end

end


-------------------------------------------
-- ɽޥɼվ֤ν
-------------------------------------------
function OnFOLLOW_CMD_ST ()

	TraceAI ("OnFOLLOW_CMD_ST")

	local ownerX, ownerY, myX, myY
	ownerX, ownerY = GetV (V_POSITION,GetV(V_OWNER,MyID))	-- ߤκɸ
	myX, myY = GetV (V_POSITION,MyID)	-- ۥκɸ

	local d = GetDistance (ownerX,ownerY,myX,myY)	-- ۥȥߤȤεΥ׻

	if ( d <= 3) then	-- Υ3ʤ
		return		-- 
	end

	-- ۥबưǰư褬ߤΥƤ顢ư򥭥󥻥뤷ƥߤɽ
	local motion = GetV (V_MOTION,MyID)
	if (motion == MOTION_MOVE) then                       -- ̵
		d = GetDistance (ownerX, ownerY, MyDestX, MyDestY)
		if ( d > 3) then		-- Υ3ΥƤ
			MoveToOwner (MyID)	-- ߤΤȤޤǰư
			MyDestX = ownerX	-- ߤκɸɸɸˤ
			MyDestY = ownerY
			return			-- 
		end
	else	-- ư椸ʤ
		MoveToOwner (MyID)	-- ߤΤȤޤǰư
		MyDestX = ownerX	-- ߤκɸɸɸˤ
		MyaDestY = ownerY
		return
	end
	
end


-------------------------------------------
-- ߤ򹶷⤷ƤŨΤۥफֶᤤŨΥ饯id
--   <> ŨΥ饯id
-------------------------------------------
function	GetOwnerEnemy (myid)
	local result = 0		-- ŨΥ饯id
	local owner  = GetV (V_OWNER,myid)	-- ߼ȤΥ饯id
	local actors = GetActors ()	-- Υ饯id
	local enemys = {}	-- ŨΥꥹ
	local index = 1		-- ǥåֹ(1)
	local target		-- åȤΥ饯id

	-- (1,actors[1])(2,actors[2])ĤΥڥ򷫤֤
	-- Υ饯idҤȤĤҤȤĥåơΥ饯
	-- ߤ򹶷⤷褦ȤƤ顢ŨȤŨꥹȤɲä
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then	-- ߤۥ༫Ȥʤ
			target = GetV (V_TARGET,v)	-- Υ饯Υ
			if (target == owner) then	-- ߤä
				if (IsMonster(v) == 1) then	-- 󥹥ä
					enemys[index] = v	-- ŨΥꥹȤɲ
					index = index+1		-- ǥå1䤹
				else	-- 󥹥ʤ
					local motion = GetV(V_MOTION,i)	-- Υ饯Υ⡼
					-- ⡼󤬹⡼ä
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v	-- ŨΥꥹȤɲ
						index = index+1	-- ǥå1䤹
					end
				end
			end
		end
	end

	local min_dis = 100	-- ǾΥ(ͤ100)
	local dis		-- Υ

	-- (1,enemys[1])(2,enemys[2])ĤΥڥ򷫤֤
	-- ŨꥹȤǡۥफֶᤤŨۥιоݤȤ
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)	-- ۥŨȤεΥ
		if (dis < min_dis) then		-- ǾΥᤱ
			result = v	-- Ũ򥿡åȤȤ
			min_dis = dis	-- ŨȤεΥǾΥȤ
		end
	end
	
	return result	-- åȤ֤
end


-------------------------------------------
-- ۥŨ
--   <> ŨΥ饯id
-------------------------------------------
function	GetMyEnemy (myid)
	local result = 0	-- ŨΥ饯id

	local type = GetV (V_HOMUNTYPE,myid)	-- ۥΥפ
	-- ۥब LIF  AMISTR ʤ
	if (type == LIF or type == LIF_H or type == AMISTR or type == AMISTR_H) then
		result = GetMyEnemyA (myid)	-- ŨA蹶
	-- ۥब FILIR  VANILMIRTH ʤ
	elseif (type == FILIR or type == FILIR_H or type == VANILMIRTH or type == VANILMIRTH_H) then
		result = GetMyEnemyB (myid)	-- ŨB蹶
	end
	return result	-- åȤ֤
end


-------------------------------------------
-- ŨA蹶
-------------------------------------------
function	GetMyEnemyA (myid)
	local result = 0	-- ŨΥ饯id
	local owner  = GetV (V_OWNER,myid)	-- ߼ȤΥ饯id
	local actors = GetActors ()	-- Υ饯id
	local enemys = {}	-- ŨΥꥹ
	local index = 1		-- ǥåֹ(1)
	local target		-- åȤΥ饯id

	-- (1,actors[1])(2,actors[2])ĤΥڥ򷫤֤
	-- Υ饯idҤȤĤҤȤĥåơΥ饯
	-- ۥ򹶷⤷褦ȤƤ顢ŨȤŨꥹȤɲä
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then	-- ߤۥ༫Ȥʤ
			target = GetV (V_TARGET,v)	-- Υ饯Υ
			if (target == myid) then	-- ۥ༫Ȥʤ
				enemys[index] = v	-- ŨΥꥹȤɲ
				index = index+1		-- ǥå1䤹
			end
		end
	end

	local min_dis = 100	-- ǾΥ(ͤ100)
	local dis		-- Υ

	-- (1,enemys[1])(2,enemys[2])ĤΥڥ򷫤֤
	-- ŨꥹȤǡۥफֶᤤŨۥιоݤȤ
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)	-- ۥŨȤεΥ
		if (dis < min_dis) then		-- ǾΥᤱ
			result = v	-- Ũ򥿡åȤȤ
			min_dis = dis	-- ŨȤεΥǾΥȤ
		end
	end

	return result
end


-------------------------------------------
-- ŨB蹶
-------------------------------------------
function	GetMyEnemyB (myid)
	local result = 0	-- ŨΥ饯id
	local owner  = GetV (V_OWNER,myid)	-- ߼ȤΥ饯id
	local actors = GetActors ()	-- Υ饯id
	local enemys = {}		-- ŨΥꥹ
	local index = 1			-- ǥåֹ(1)
	local type		-- (̤)

	-- (1,actors[1])(2,actors[2])ĤΥڥ򷫤֤
	-- Υ饯idҤȤĤҤȤĥåơΥ饯
	-- 󥹥ä顢ŨȤŨꥹȤɲä
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then	-- ߤۥ༫Ȥʤ
			if (1 == IsMonster(v))	then	-- 󥹥ä
				enemys[index] = v	-- ŨΥꥹȤɲ
				index = index+1		-- ǥå1䤹
			end
		end
	end

	local min_dis = 100	-- ǾΥ(ͤ100)
	local dis		-- Υ

	-- (1,enemys[1])(2,enemys[2])ĤΥڥ򷫤֤
	-- ŨꥹȤǡۥफֶᤤŨۥιоݤȤ
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)	-- ۥŨȤεΥ
		if (dis < min_dis) then		-- ǾΥᤱ
			result = v	-- Ũ򥿡åȤȤ
			min_dis = dis	-- ŨȤεΥǾΥȤ
		end
	end

	return result
end


-------------------------------------------
-- ۥ󥯥륹AIᥤ
-------------------------------------------
function AI(myid)

	MyID = myid	-- ۥ༫ȤΥ饯id
	local msg	= GetMsg (myid)		-- ߤϤޥ
	local rmsg	= GetResMsg (myid)	-- Ϥ줿ޥ

	-- ޥɤȤοʬ
	if msg[1] == NONE_CMD then		-- ޥϤʤ
		if rmsg[1] ~= NONE_CMD then	-- Ϥ줿ޥɤ
			if List.size(ResCmdList) < 10 then	-- ϥޥɤ10̤ʤ
				List.pushright (ResCmdList,rmsg)	-- ϥޥɥꥹȤɲ
			end
		end
	else	-- ޥϤ
		List.clear (ResCmdList)	-- ϥޥɥꥹȤ򥯥ꥢ
		ProcessCommand (msg)	-- ۥΥơ򹹿
	end

	-- ۥ֤ȤνƤӽФ
 	if (MyState == IDLE_ST) then	-- Ե
		OnIDLE_ST ()
	elseif (MyState == CHASE_ST) then	-- å׾
		OnCHASE_ST ()
	elseif (MyState == ATTACK_ST) then	-- 
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then	-- 륱ߥɽ
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then	-- ưޥɼվ
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then	-- ߥޥɼվ
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then	-- оݻ깶⥳ޥɼվ
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then	-- ϰϹ⥳ޥɼվ
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then	-- ѥȥ륳ޥɼվ
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then	-- ۡɥޥɼվ
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then	-- оݻꥹ륳ޥɼվ
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then	-- ϰϥ륳ޥɼվ
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then	-- ɽޥɼվ
		OnFOLLOW_CMD_ST ()
	end

end
